#include <stdio.h>

#define SIZE  (100000000)

main(int argc, char **argv) {
   int i, n, max;
   unsigned char *array, tmpbyte[4]; 
   array = (unsigned char *) malloc(SIZE*sizeof(unsigned char));
   n = fread(array, sizeof(unsigned char), SIZE, stdin);
   if (n == SIZE) {
      fprintf(stderr, "Error: size limit reached\n");
      exit(-1);
      }
   max = n;
   if (argc == 2) max = atoi(argv[1]);
   for(i = 0; i < max; i += 4) {
      tmpbyte[0]    = array[i+0];
      tmpbyte[1]    = array[i+1];
      tmpbyte[2]    = array[i+2];
      tmpbyte[3]    = array[i+3];
      array[i+0]    = tmpbyte[3];
      array[i+1]    = tmpbyte[2];
      array[i+2]    = tmpbyte[1];
      array[i+3]    = tmpbyte[0];
      }
   fwrite(array, sizeof(unsigned char), n, stdout);
   free(array);
}

