c     file for testing FORTRAN subroutines

      subroutine emptyf()

      return
      end


      subroutine dv2d1(v1 , v2 , v3 , f01, f02, f03, f04, f05, f06,
     x                 f07, f08, f09, f10, f11, f12, f13, f14, f15,
     x                 f16, c1, c2, d)
      real*4 v1(1), v2(1), v3(1)
      real*4 f01(1), f02(1), f03(1), f04(1), f05(1), f06(1) 
      real*4 f07(1), f08(1), f09(1), f10(1), f11(1), f12(1)
      real*4 f13(1), f14(1), f15(1), f16(1)
      real*4 c1, c2
      integer d, n

      do n = 1, d
        v1(n) = v1(n) + (c1*(f03(n) - f02(n) + f07(n) - f06(n)) +
     x                   c2*(f04(n) - f01(n) + f08(n) - f05(n)))*v3(n)
        v2(n) = v2(n) + (c1*(f11(n) - f10(n) + f15(n) - f14(n)) +
     x                   c2*(f12(n) - f09(n) + f16(n) - f13(n)))*v3(n)
      enddo

      return
      end


      subroutine dv2d2(v1 , v2 , v3 , v4 , f01, f02, f03, f04, f05, f06,
     x                      f07, f08, f09, f10, f11, f12, f13, f14, f15,
     x                      f16, c1, c2, d)
      real*4 v1(1), v2(1), v3(1), v4(1)
      real*4 f01(1), f02(1), f03(1), f04(1), f05(1), f06(1) 
      real*4 f07(1), f08(1), f09(1), f10(1), f11(1), f12(1)
      real*4 f13(1), f14(1), f15(1), f16(1)
      real*4 c1, c2
      integer d, n

      do n = 1, d
        v1(n) = v1(n) + (c1*(f03(n) - f02(n) + f07(n) - f06(n)) +
     x                   c2*(f04(n) - f01(n) + f08(n) - f05(n)))*v3(n)
        v2(n) = v2(n) + (c1*(f11(n) - f10(n) + f15(n) - f14(n)) +
     x                   c2*(f12(n) - f09(n) + f16(n) - f13(n)))*v4(n)
      enddo

      return
      end


      subroutine dt2d1(v1 , v2 , v3 , v4 , v5 , f01, f02, f03, f04,
     x                 f05, f06, f07, f08, f09, f10, f11, f12, f13, 
     x                 f14, f15, f16, c1, c2, d)
      real*4 v1(1), v2(1), v3(1), v4(1), v5(1)
      real*4 f01(1), f02(1), f03(1), f04(1), f05(1), f06(1) 
      real*4 f07(1), f08(1), f09(1), f10(1), f11(1), f12(1)
      real*4 f13(1), f14(1), f15(1), f16(1)
      real*4 c1, c2
      real*4 h01, h02, h03
      integer d, n

      do n = 1, d
        h01 = c1*(f03(n) - f02(n)) + c2*(f04(n) - f01(n))
        h02 = c1*(f07(n) - f06(n)) + c2*(f08(n) - f05(n))
        h03 = v5(n) + v5(n) + v4(n)
        v1(n) = v1(n) + h03*h01 + h02*v4(n)
        v2(n) = v2(n) + h03*h02 + h01*v4(n)
        v3(n) = v3(n) + (c1*(f11(n) - f10(n) + f15(n) - f14(n)) +
     x                   c2*(f12(n) - f09(n) + f16(n) - f13(n)))*v5(n)
      enddo

      return
      end


      subroutine dt2d2(v1 , v2 , v3 , v4 , v5 , v6 , f01, f02, f03, f04,
     x                      f05, f06, f07, f08, f09, f10, f11, f12, f13, 
     x                      f14, f15, f16, c1, c2, d)
      real*4 v1(1), v2(1), v3(1), v4(1), v5(1), v6(1)
      real*4 f01(1), f02(1), f03(1), f04(1), f05(1), f06(1) 
      real*4 f07(1), f08(1), f09(1), f10(1), f11(1), f12(1)
      real*4 f13(1), f14(1), f15(1), f16(1)
      real*4 c1, c2
      real*4 h01, h02, h03
      integer d, n

      do n = 1, d
        h01 = c1*(f03(n) - f02(n)) + c2*(f04(n) - f01(n))
        h02 = c1*(f07(n) - f06(n)) + c2*(f08(n) - f05(n))
        h03 = v5(n) + v5(n) + v4(n)
        v1(n) = v1(n) + h03*h01 + h02*v4(n)
        v2(n) = v2(n) + h03*h02 + h01*v4(n)
        v3(n) = v3(n) + (c1*(f11(n) - f10(n) + f15(n) - f14(n)) +
     x                   c2*(f12(n) - f09(n) + f16(n) - f13(n)))*v6(n)
      enddo

      return
      end


      subroutine dv3d1(v1 , v4 , f01, f02, f03, f04, f05, f06,
     x                 f07, f08, f09, f10, f11, f12, c1, c2, d)
      real*4 v1(1), v4(1)
      real*4 f01(1), f02(1), f03(1), f04(1), f05(1), f06(1) 
      real*4 f07(1), f08(1), f09(1), f10(1), f11(1), f12(1)
      real*4 c1, c2
      integer d, n

      do n = 1, d
        v1(n) = v1(n) + (c1*(f03(n) - f02(n)  + 
     x                       f07(n) - f06(n)  +
     x                       f11(n) - f10(n)) +
     x                   c2*(f04(n) - f01(n)  + 
     x                       f08(n) - f05(n)  +
     x                       f12(n) - f09(n)))*v4(n)
      enddo

      return
      end


      subroutine dt3d1(v1 , v2 , v3 , v7 , v8 , f01, f02, f03, f04,
     x                 f05, f06, f07, f08, f09, f10, f11, f12, 
     x                 c1, c2, d)
      real*4 v1(1), v2(1), v3(1), v7(1), v8(1)
      real*4 f01(1), f02(1), f03(1), f04(1), f05(1), f06(1) 
      real*4 f07(1), f08(1), f09(1), f10(1), f11(1), f12(1)
      real*4 c1, c2
      real*4 h01, h02, h03, h04, h05
      integer d, n

      do n = 1, d
        h01 = c1*(f03(n) - f02(n)) + c2*(f04(n) - f01(n))
        h02 = c1*(f07(n) - f06(n)) + c2*(f08(n) - f05(n))
        h03 = c1*(f11(n) - f10(n)) + c2*(f12(n) - f09(n))
        h04 = (h01 + h02 + h03)*v7(n)
        h05 = v8(n) + v8(n) 
        v1(n) = v1(n) + h05*h01 + h04
        v2(n) = v2(n) + h05*h02 + h04
        v3(n) = v3(n) + h05*h03 + h04
      enddo

      return
      end


      subroutine dt3d2(v4 , v8 , f01, f02, f03, f04, 
     x                 f05, f06, f07, f08, c1, c2, d)
      real*4 v4(1), v8(1)
      real*4 f01(1), f02(1), f03(1), f04(1), f05(1), f06(1) 
      real*4 f07(1), f08(1)
      real*4 c1, c2
      integer d, n

      do n = 1, d
        v4(n) = v4(n) + (c1*(f03(n) - f02(n) + f07(n) - f06(n)) +
     x                   c2*(f04(n) - f01(n) + f08(n) - f05(n)))*v8(n)
      enddo

      return
      end



c attenuation subroutines, for 3D

      subroutine da3f(rxx, ryy, rzz, Txx, Tyy, Tzz, lamda, mu, 
     x                F0, F1, F2, dv1, dv2, dv3, dt, l)
      real*4 rxx(1), ryy(1), rzz(1), Txx(1), Tyy(1), Tzz(1)
      real*4 lamda(1), mu(1), F0(1), F1(1), F2(1), dt
      real*4 dv1(1), dv2(1), dv3(1), s1, s2, s3, fdv, D1, D2
      integer l, n

      do n = 1, l
         s1 = rxx(n)
         s2 = ryy(n)
         s3 = rzz(n)
         fdv = F1(n)*(dv1(n) + dv2(n) + dv3(n))
         rxx(n) = F0(n)*s1 + fdv + F2(n)*(dv2(n) + dv3(n))
         ryy(n) = F0(n)*s2 + fdv + F2(n)*(dv1(n) + dv3(n))        
         rzz(n) = F0(n)*s3 + fdv + F2(n)*(dv2(n) + dv1(n))
         s1 = (s1 + rxx(n))*0.5
         s2 = (s2 + ryy(n))*0.5
         s3 = (s3 + rzz(n))*0.5
         D1 = (lamda(n) + 2.*mu(n))
         D2 = (lamda(n))
c        s1 = 0.
c        s2 = 0.
c        s3 = 0.
         Txx(n) = Txx(n) + dt*(D1*dv1(n) + D2*(dv2(n) + dv3(n)) + s1)
         Tyy(n) = Tyy(n) + dt*(D1*dv2(n) + D2*(dv1(n) + dv3(n)) + s2)
         Tzz(n) = Tzz(n) + dt*(D1*dv3(n) + D2*(dv1(n) + dv2(n)) + s3)
      enddo
      return
      end

      
      subroutine da4f(rxy, rxz, ryz, Txy, Txz, Tyz, muxy, muxz, muyz,
     x                F0, F3, dv1, dv2, dv3, dv4, dv5, dv6, dt, l)
      real*4 rxy(1), rxz(1), ryz(1), Txy(1), Txz(1), Tyz(1)
      real*4 F0(1), F3(1), dt, dv4(1), dv5(1), dv6(1)
      real*4 muxy(1), muxz(1), muyz(1)
      real*4 dv1(1), dv2(1), dv3(1), s3, s4, s5 
c     real*4 D1, D2
      integer l, n
      
      do n = 1, l
         s3 = rxy(n)
         s4 = rxz(n)
         s5 = ryz(n)
         rxy(n) = F0(n)*s3 + F3(n)*(dv3(n) + dv6(n))
         rxz(n) = F0(n)*s4 + F3(n)*(dv1(n) + dv4(n))
         ryz(n) = F0(n)*s5 + F3(n)*(dv2(n) + dv5(n))
         s3 = (s3 + rxy(n))*0.5
         s4 = (s4 + rxz(n))*0.5
         s5 = (s5 + ryz(n))*0.5
c        s3 = 0.
c        s4 = 0.
c        s5 = 0.
c        Txy(n) = Txy(n) + dt*muxy(n)*(dv4(n) + dv1(n)) + dt*s3
c        Txz(n) = Txz(n) + dt*muxz(n)*(dv5(n) + dv2(n)) + dt*s4
c        Tyz(n) = Tyz(n) + dt*muyz(n)*(dv6(n) + dv3(n)) + dt*s5
         Txy(n) = Txy(n) + dt*muxy(n)*(dv3(n) + dv6(n)) + dt*s3
         Txz(n) = Txz(n) + dt*muxz(n)*(dv1(n) + dv4(n)) + dt*s4
         Tyz(n) = Tyz(n) + dt*muyz(n)*(dv2(n) + dv5(n)) + dt*s5
      enddo
      return
      end

