/* NEED TO FIX */

/* ERROR: NEED TO FIX/TEST MPI CSEND for mpWindow */

/******************************************************************************
   mpmpi: compatibility functions for parallel mpsi to mpi machines calls

   compile: cc -g -c mpmpi.c 

   author: shawn larsen
   date  : february 1996
   where : llnl
*****************************************************************************/

#include <stdio.h>
#include <mpi.h>

static MPI_Group    group;
static MPI_Datatype datatype = MPI_BYTE;   /* DON'T KNOW ABOUT THIS */
static MPI_Request  request;               /* DON'T KNOW ABOUT THIS */
static int          mpi_nrequest = 0;

void mpsc_init(argc, argv) 
int    *argc;
char ***argv;
{
MPI_Init(argc, argv);
MPI_Comm_group(MPI_COMM_WORLD, &group);
}

void mpsc_fini() {MPI_Finalize();}

void gsync() 
{
MPI_Barrier(MPI_COMM_WORLD);
}

int mynode() 
{
int node;
MPI_Group_rank(group, &node);
return(node);
}

int numnodes() 
{
int nnode;
MPI_Group_size(group, &nnode);
return(nnode);
}

void
csend(type, buffer, length, node, pid)
int type, length, node, pid;
void *buffer;
{
if (node != -1) {
   MPI_Send(buffer, length, datatype, node, type, MPI_COMM_WORLD);
   }
else {
   /*   int i, node, nnode; */
   fprintf(stderr, "ERROR: NEED TO FIX/TEST MPI CSEND for mpWindow\n");
   exit(-1);
   }
}

void
crecv(type, buffer, length)
int type, length;
void *buffer;
{
MPI_Status status;
MPI_Recv(buffer, length, datatype, MPI_ANY_SOURCE, type, MPI_COMM_WORLD,
         &status);
}

int
isend(type, buffer, length, node, pid)
int type, length, node, pid;
void *buffer;
{
MPI_Isend(buffer, length, datatype, node, type, MPI_COMM_WORLD, &request);
return(++mpi_nrequest); /* DON'T KNOW ABOUT THIS */
}

int
irecv(type, buffer, length)
int type, length;
void *buffer;
{
MPI_Irecv(buffer, length, datatype, MPI_ANY_SOURCE, type, MPI_COMM_WORLD, 
          &request);
return(++mpi_nrequest); /* DON'T KNOW ABOUT THIS */
}

int
msgwait(id)
int id;
{
MPI_Status status;
if (mpi_nrequest > 1) {fprintf(stderr, "Error: mpi_nrequest > 1\n"); exit(-1);}
MPI_Wait(&request, &status);
if (--mpi_nrequest < 0) {fprintf(stderr,"Error: mpi_nrequest < 0\n");exit(-1);}
return(mpi_nrequest + 1);
}

void
gshigh(x, n, work)
float *x, *work;
int n;
{
float y;
MPI_Allreduce(x, &y, n, MPI_FLOAT, MPI_MAX, MPI_COMM_WORLD);
*x = y; 
}

void
gslow(x, n, work)
float *x, *work;
int n;
{
float y;
MPI_Allreduce(x, &y, n, MPI_FLOAT, MPI_MIN, MPI_COMM_WORLD);
*x = y; 
}

int mclock() {return(((int) clock())/1000.);}
